#include "ClassBox.h"
#include "LinkPoint.h"
#include "MyResizer.h"
#include "UClass.h"
#include "UITools.h"
#include "cortex_ui.h"
#include "MediaWire.h"

#define 	REZ		4
#define	LIN		10

extern UITools*	ui_tools;

ClassBox::ClassBox(BRect r):StructBox(r){
	
	
	// linker
	addItem(new LinkPoint(BRect(r.left+2,r.top+2,r.left+LIN+2,r.top+2+LIN)));
	// resizer
	addItem(m_resizer=new MyResizer(BRect(r.right-REZ,r.bottom-REZ,r.right,r.bottom)));
	
}

void
ClassBox::StructChanged(BRect* out)
{
	// calcoliamo la min e la max width??
	if(!getStruct()) return;
	
	
	UClass *cls= (UClass*)getStruct();
	
	BPoint to;
	to.x=ui_tools->getBoldFont()->StringWidth(cls->class_name.String())+50;
	to.y=40;
	
	float max=to.x;
	int i;
	for(i=0;i<cls->CountAttributes();i++)
	{
	
		max=ui_tools->getRegularFont()->StringWidth(cls->AttributeAt(i)->name.String())+20;
		if(max>to.x) to.x=max;
	}
	
	 to.y+=cls->CountAttributes()*20;
	 
	for(i=0;i<cls->CountMethods();i++)
	{
		max=ui_tools->getRegularFont()->StringWidth(cls->MethodAt(i)->name.String())+20;
		if(max>to.x) to.x=max;
	}
	
	to.y+=cls->CountMethods()*20;
	
	
	to.x -=frame().Width();
	//if(to.x<0) to.x=0;
	
	to.y -=frame().Height();
	//if(to.y<0) to.y=0;
		
	BRegion m_update;
	
	//include also the frame of my wiers (for centerpoint)
	for(int32 i=getCenterEndPoint()->CountConnectedWires()-1;i>=0;i--)
	{
		MediaWire *mw=(MediaWire*)getCenterEndPoint()->wire(i);
		m_update.Include(mw->frame());
	}
	
	m_update.Include(frame());
	resizeBy(to.x,to.y);
	
	m_resizer->moveBy(to.x,to.y);
	moveBy(0,0,&m_update);
	
	
	*out=m_update.Frame();
}

void
ClassBox::drawBox(){


	
	ui_tools->ApplyBoldFont(view());
	
	view()->SetHighColor(255,255,255); 
	 	
		view()->FillRect(frame()); 
			
		if(isSelected())
		 
			view()->SetHighColor(255,0,0); 
		else
			view()->SetHighColor(0,0,0);
		
		
			if(getStruct())
			{
				UClass *cls= (UClass*)getStruct();
				//name
				view()->DrawString(cls->class_name.String(),frame().LeftTop()+BPoint((frame().Width()/2)-(view()->StringWidth(cls->class_name.String())/2),12));
					
				//view()->SetFont(be_plain_font);
				ui_tools->ApplyRegularFont(view());
				//line			
				view()->StrokeLine(BPoint(frame().left,frame().top+20),BPoint(frame().right,frame().top+20));
			 	float	 posY=frame().top+23;
			 	float posX=frame().left+10;
				//attributes 
				int i;
	        	for(i=0;i<cls->CountAttributes();i++)
	        	{
	        		posY+=15;
	        		if(posY >=frame().bottom) goto exit;
	        		view()->DrawString(cls->AttributeAt(i)->name.String(),BPoint(posX,posY));
	        		
				}
				posY+=5; 
				if(i==0) posY+=5; 
			    view()->StrokeLine(BPoint(frame().left,posY),BPoint(frame().right,posY));
				
				for(int i=0;i<cls->CountMethods();i++)
	        	{
	        		posY+=15;
	        		if(posY >=frame().bottom) goto exit;
	        		view()->DrawString(cls->MethodAt(i)->name.String(),BPoint(posX,posY));
	        		
				}
			
			}
			
		exit:
		view()->StrokeRect(frame());
		
}
