#include "ClassPanel.h"
#include "UClass.h"
#include "stdio.h"


#include <ScrollView.h>
#include <TabView.h>
#include <Button.h>

BButton *a,*b;
BTabView *tabView;

ClassPanel::ClassPanel(UClass* cls):BBox(BRect(0,0,200,250)),
m_class(cls)
{
	AddChild(txt_classname=new BTextControl(BRect(20,15,180,40),"nome","Name","",new BMessage(B_QUIT_REQUESTED)));
	
	txt_classname->SetDivider(50);
	//txt_classname->SetInvokationMessage(NULL);
	BTab *tab;
	BRect r(20,50,180,180);
	tabView = new BTabView(r, "tab_view",B_WIDTH_FROM_LABEL);
	r = tabView->Bounds();
	r.InsetBy(5,5);
	r.bottom -= tabView->TabHeight();
	r.right-=14;
	tab = new BTab();
	list=new BListView(r, "", B_SINGLE_SELECTION_LIST);
	tabView->AddTab(new BScrollView("scroll_cities", list,B_FOLLOW_LEFT | B_FOLLOW_TOP, 0, false, true), tab);
	tab->SetLabel("Attributes");
	tab = new BTab();
	list2=new BListView(r, "", B_SINGLE_SELECTION_LIST);
	tabView->AddTab(new BScrollView("", list2,B_FOLLOW_LEFT | B_FOLLOW_TOP, 0, false, true), tab);
	tab->SetLabel("Methods");
	
	
	AddChild(tabView);
	
	AddChild(txt_methodname=new BTextControl(BRect(20,185,180,205),"nome",NULL,"",new BMessage('add0')));
	AddChild(b=new BButton(BRect(20,210,95,230),"Add","Add",new BMessage('azz0') ));
	AddChild(a=new BButton(BRect(105,210,180,230),"Remove","Remove",new BMessage('rem0') ));
	
}

void
ClassPanel::AttachedToWindow()
{
	txt_classname->SetText(m_class->class_name.String());
	b->SetTarget(this);
	a->SetTarget(this);
	txt_methodname->SetTarget(this);
	
	for(int32 i=0;i<m_class->CountAttributes();i++)
	{
		Attribute* att=m_class->AttributeAt(i);
		list->AddItem(new BStringItem(att->name.String()));
	}
	for(int32 i=0;i<m_class->CountMethods();i++)
	{
		Method*	met=m_class->MethodAt(i);
		list2->AddItem(new BStringItem(met->name.String()));
	}

	txt_classname->MakeFocus(true);
}

void
ClassPanel::DetachedFromWindow()
{
	m_class->class_name=txt_classname->Text();
	m_class->setStructName(txt_classname->Text());
}
void
ClassPanel::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
	case 'azz0':
	
		if(strlen(txt_methodname->Text())==0) return;
		
		if(tabView->Selection()==0)
		{
			list->AddItem(new BStringItem(txt_methodname->Text()));
			m_class->AddAttribute(new Attribute(txt_methodname->Text()));
		}
		 else
		 {
		 	list2->AddItem(new BStringItem(txt_methodname->Text()));
		 	m_class->AddMethod(new Method(txt_methodname->Text()));
		 }	
		txt_methodname->SetText("");
	break;
	
	case	'rem0':
		if(tabView->Selection()==0)
		{
			m_class->RemoveAttributeAt(list->CurrentSelection());
			list->RemoveItem(list->CurrentSelection());
						
		}
		 else
		 {
		 	m_class->RemoveMethodAt(list2->CurrentSelection());
		 	list2->RemoveItem(list2->CurrentSelection());
		 	
		 }
	break;
	
	default:
		BBox::MessageReceived(message);
	break;
	}
}