#ifndef _EndRelation_h_
#define _EndRelation_h_
enum {
	W_RIGHT,
	W_LEFT,
	W_TOP,
	W_BOTTOM
};
#include "cortex_ui.h"
#include "TranslationUtils.h"
#include "Rect.h"
#include <View.h>

class EndRelation
{
public:
			  EndRelation(BRect r,int id,BBitmap* bit=NULL){
			  	
			  	m_frame=r; 
			  	map=bit;
			  	m_id=id;
			   
			   if(bit)
			   	   	 {h=r.Height(); w=r.Width(); m_direction=-1;}
			  
			   else
			   		    	
			    	h=w=0;
			    	
			   
			   
			  };
	
		int		getID(){ return m_id;}
		virtual BRect frame(){ return m_frame;};
		
		virtual void draw(BView* view)
		{
			if(!map) return;
			
			view->SetDrawingMode(B_OP_ALPHA);
			switch(getDir())
			{
					
			case W_LEFT:
				view->DrawBitmap(map,BRect(0,0,20,20),m_frame);
			break;
			case W_TOP:
				view->DrawBitmap(map,BRect(21,0,41,20),m_frame);
			break;
			case W_RIGHT:
				view->DrawBitmap(map,BRect(42,0,62,20),m_frame);
			break;
			
			case W_BOTTOM:
				view->DrawBitmap(map,BRect(63,0,83,20),m_frame);
			break;
			default:
			break;
			}
			
			view->SetDrawingMode(B_OP_COPY);		
		};
		
		void moveTo(float x,float y)
		{
			m_frame.top=y;
			m_frame.left=x;
			m_frame.bottom=y+h;
			m_frame.right=x+w;
		}
		
		void offsetDir(float x, float y,int32 dir,BPoint *p)
		{
			switch(dir)
			{
			case W_RIGHT:
				moveTo(x,y-h/2.0);
				*p = BPoint(x+w,y);
			break;
			case W_LEFT:
				moveTo(x-w,y-h/2.0);
				*p = BPoint(x-w,y);
			break;
			case W_TOP:
				moveTo(x-w/2.0,y-h);
				*p = BPoint(x,y-h);
			break;
			case W_BOTTOM:
				moveTo(x-w/2.0,y);
				*p = BPoint(x,y+h);
			break;
			default:
			break;
			}
			m_direction=dir;
		}
		
		int32 getDir(){ return m_direction;};
		
private:
		BRect 	m_frame;
		float		h,w;
		int		m_direction;
		int		m_id;
		BBitmap *map;
	
};

#endif