// LineWire.h
// c.lenz 10oct99
//
// HISTORY
//

#ifndef __LineWire_H__
#define __LineWire_H__

// DiagramView
#include "DiagramWire.h"
// NodeManager
#include "MyEndPoint.h"

#include "cortex_defs.h"
__BEGIN_CORTEX_NAMESPACE

class MediaJack;

class LineWire :
	public		DiagramWire {
	typedef		DiagramWire _inherited;

public:					// *** constans

	// [e.moon 26oct99] moved definition to LineWire.cpp
	static const float		M_WIRE_OFFSET;

public:					// *** ctor/dtor

	// input and output jack are set connected by this constructor
	// so be careful to only pass in valid pointers
						LineWire(
							DiagramEndPoint *outputJack,
							DiagramEndPoint *inputJack);

	// special constructor used only in drag&drop sessions for
	// temporary visual indication of the connection process
	// the isStartPoint specifies if the given EndPoint is 
	// supposed to be treated as start or end point
						LineWire(
							DiagramEndPoint *jack,
							bool isStartPoint);

	virtual				~LineWire();
	
public:					// *** accessors

	//Connection			connection;

public:					// *** derived from DiagramWire/Item

	// init the cached points and the frame rect
	virtual void		attachedToDiagram();

	// make sure no tooltip is being displayed for this wire
	// +++ DOES NOT WORK (yet)
	virtual void		detachedFromDiagram();

	// calculates and returns the frame rectangle of the wire
	virtual BRect		frame() const;

	virtual void		drawWire();

	// updates the cached start & end points and the frame rect
	virtual void		endPointMoved(
							DiagramEndPoint *which = 0);



private:					// *** data members

	BPoint				m_startPoint;
	
	BPoint				m_endPoint;
	
	BPoint				m_startOffset;
	
	BPoint				m_endOffset;
	
	BRect				m_frame;
};

__END_CORTEX_NAMESPACE
#endif /* __LineWire_H__ */
