#ifndef _MY_RESIZER_
#define _MY_RESIZER_
#include "DiagramItem.h"
#include "Message.h"

class MyResizer : public DiagramItem
{
	public:
		MyResizer(BRect r):DiagramItem(DiagramItem::M_ENDPOINT),m_rect(r){};
		
		virtual BRect	frame() const { return m_rect; };
		virtual void	draw(BRect updateRect){
	
		view()->SetHighColor(255,255,255);
		view()->FillRect(frame()); 
		view()->SetHighColor(0,0,0);
		view()->StrokeRect(frame()); 
		};
		
		
		virtual void		moveBy(
							float x,
							float y,
							BRegion *updateRegion = 0){ m_rect.OffsetBy(x, y); };
	
	
		virtual void mouseDown(
	BPoint point,
	uint32 buttons,
	uint32 clicks)
{
	if ( (buttons == B_PRIMARY_MOUSE_BUTTON))
	if (clicks == 1)
	{
			BMessage dragMsg('ziza');
			dragMsg.AddPointer("item", static_cast<void *>(this));
			dragMsg.AddPoint("from",view()->ConvertToScreen(point));
			BRect intersex=(((DiagramBox*)(group()))->frame() );
			view()->DragMessage(&dragMsg, BRect(0.0, 0.0, -1.0, -1.0), view());
			view()->BeginRectTracking(intersex, B_TRACK_RECT_CORNER);
	}
	else
	if (clicks == 2)
	{
			StructBox *box=(StructBox*)group();
			BMessage *msg=new BMessage('refr');
			msg->AddPointer("fromBox",(void*)box);
			view()->Window()->PostMessage(msg,view());
			
	}
}
	
	private:
		BRect m_rect;
	
	};
#endif