#include "NoteBox.h"
#include "LinkPoint.h"
#include "MyResizer.h"
#include "UNote.h"
#include "UITools.h"
#include "cortex_ui.h"
#include "MediaWire.h"

#define 	REZ		4
#define	LIN		10

extern UITools*	ui_tools;

#include "stdio.h"

#include <TextView.h>
#include <Box.h>

NoteBox::NoteBox(BRect r):StructBox(r),m_bitmap(NULL){
	
	
	// linker
	addItem(new LinkPoint(BRect(r.left+2,r.top+2,r.left+LIN+2,r.top+2+LIN)));
	// resizer
	addItem(m_resizer=new MyResizer(BRect(r.right-REZ,r.bottom-REZ,r.right,r.bottom)));
	
}

void
NoteBox::StructChanged(BRect* out)
{
	// calcoliamo la min e la max width??
	if(!getStruct()) return;
	

	_updateBitmap();
	*out=frame();
}
void
NoteBox::resizeBy(float x,float y)
{
	StructBox::resizeBy(x,y);
	_updateBitmap();	
}

void
NoteBox::drawBox(){

	if(m_bitmap){
		view()->DrawBitmap(m_bitmap,frame());
		
		}
	if(isSelected())
		 
		view()->SetHighColor(255,0,0); 
		else
		view()->SetHighColor(0,0,0);
		
	view()->StrokeRect(frame());
	view()->StrokeTriangle(BPoint(frame().right-15,frame().top),BPoint(frame().right-15,frame().top+15),BPoint(frame().right,frame().top+15));
	view()->SetHighColor(view()->LowColor()); 	
	view()->FillTriangle(BPoint(frame().right-14,frame().top),BPoint(frame().right,frame().top),BPoint(frame().right,frame().top+14));

	
	
}
void NoteBox::_updateBitmap(bool calcsize=false,float *w=NULL,float *h=NULL)
{
	if(!getStruct()) return;
	UNote *m_note=(UNote*)getStruct();
	if (m_bitmap)
	{
		delete m_bitmap;
	}

	BBitmap *tempBitmap = new BBitmap(frame().OffsetToCopy(0.0, 0.0), B_CMAP8, true);
	tempBitmap->Lock();
	{
		BRect bb=tempBitmap->Bounds();
		bb.InsetBy(18,5);
		BTextView *tempView = new BTextView(tempBitmap->Bounds(),NULL,bb,B_FOLLOW_NONE,0);
		tempBitmap->AddChild(tempView);
		tempView->SetStylable(true);
		if(m_note->tra)
		tempView->SetText(m_note->note_text.String(),BTextView::UnflattenRunArray(m_note->tra));
		 else
		tempView->SetText(m_note->note_text.String());
		
		tempView->Draw(tempView->Bounds());
		tempView->Sync();
		
		//still in beta..
		/*if(calcsize && w && h)
		{
			
		  int n = tempView->CountLines();
		  float t;
		  float filewidth = 1;
		  for(int i = 0; i < n; i++){
		  	 t = tempView->LineWidth(i);
		 	 printf("%d - line %f \n",i,t);
		 	 if(t > filewidth) filewidth = t;
		 	 
		  }
		  
		  *w=filewidth;	  
		}*/
				
		tempBitmap->RemoveChild(tempView);
		delete tempView;
	}
	tempBitmap->Unlock();
	m_bitmap = new BBitmap(tempBitmap);
	delete tempBitmap;
}
