#ifndef _StructBox_h_
#define _StructBox_h_

#include "DiagramBox.h"
#include "UStruct.h"
#include "MyEndPoint.h"

#include <Message.h>
#include <Messenger.h>
#include <PopUpMenu.h>
#include <MenuItem.h>

class StructTriple;
class MyBox;

class StructBox : public DiagramBox
{
		public:
				StructBox(BRect r):DiagramBox(r)
				{
					m_struct=NULL;
					r.InsetBy(r.Width()/2-1,r.Height()/2-1);
					center_point=new MyEndPoint(r);
					addItem(center_point);
					m_m=r.Height()/r.Width();	
				};
				
		UStruct*	getStruct(){ return m_struct;};
		void			setStruct(UStruct *s){ m_struct=s;}
		
		virtual void mouseDown(BPoint point,uint32 buttons,	uint32 clicks){
		DiagramBox::mouseDown(point,buttons,clicks);
		if (clicks==1 && (buttons == B_SECONDARY_MOUSE_BUTTON))
		{
			
			showContextMenu(point);
			
		}
		
			
		};
	
		MyEndPoint*		getCenterEndPoint(){ return center_point;};
		float				getM() { return m_m;}
		
		virtual void		attachedToDiagram() { m_m=frame().Height()/frame().Width();	};
		
		virtual void 		resizeBy(float horizontal,float vertical)
						{
							DiagramBox::resizeBy(horizontal,vertical);
							center_point->moveBy(horizontal/2.0,vertical/2.0,0);
							m_m=frame().Height()/frame().Width();	
						};
	
		virtual void StructChanged(BRect*){};
		
	protected:
		friend StructTriple;
		friend MyBox;
				StructTriple*	m_triple;					
	private:
	
			MyEndPoint*	center_point;
			float			m_m;	
			UStruct*	m_struct;
			
			void showContextMenu(
	BPoint point)
{


	BPopUpMenu *menu = new BPopUpMenu("MediaNodePanel PopUp", false, false, B_ITEMS_IN_COLUMN);
	menu->SetFont(be_plain_font);

	BMenuItem *item;
	BMessage *message;
	
	
	message = new BMessage('pane');
	message->AddPointer("fromBox",(void*)this);
	
	menu->AddItem(item = new BMenuItem("Properties", message));
	menu->AddSeparatorItem();
	BMessage *message2 = new BMessage('dele');
	message2->AddPointer("fromBox",(void*)this);
	menu->AddItem(item = new BMenuItem("Delete",message2));
	
	menu->SetTargetForItems(view());
	view()->ConvertToScreen(&point);
	point -= BPoint(1.0, 1.0);
	message->AddPoint("where",point);
	menu->Go(point, true, true, true);
}

};
#endif