#ifndef _UClass_h_
#define _UClass_h_

#include <List.h>
#include <String.h>
#include "UStruct.h"

class  Attribute 
{
	public:
		Attribute(const char* n){name=n;}
		BString name;
	
};
class  Method 
{
	public:
		Method(const char* n){name=n;}
		BString name;
	
};
class UClass : public UStruct
{
	public:
			UClass();
								
			BString	class_name;
			//count
			int32		CountAttributes(){ return attributes->CountItems();};
			int32		CountMethods(){ return methods->CountItems();};
			//get
			Attribute*	AttributeAt(int32 i){ return (Attribute*)attributes->ItemAt(i); };
			Method*		MethodAt(int32 i){ return (Method*)methods->ItemAt(i); };
			//set
			void			AddAttribute(Attribute *a){ attributes->AddItem((void*)a); };
			void			AddMethod(Method	*m){ methods->AddItem((void*)m); };		
			//del
			void			RemoveAttributeAt(int32 i){  attributes->RemoveItem(i); };
			void			RemoveMethodAt(int32 i){  methods->RemoveItem(i); };				
	private:
			BList*		attributes;
			BList*		methods;		
			
};

inline UClass::UClass():UStruct() 
{
	class_name="No name";
	setStructName(class_name.String());
	attributes=new BList(1);
	methods=new BList(1);
	
}

#endif