
#include "BitmapMenuItem.h"
#include "cortex_ui.h"

#include "stdio.h"

BitmapMenuItem::BitmapMenuItem(const char* name, BBitmap* bitmap,BRect rect,
	BMessage* message, char shortcut, uint32 modifiers)
	: BMenuItem(name, message, shortcut, modifiers),
	m_bitmap(bitmap),m_rect(rect)
{

}

void BitmapMenuItem::Draw(void)
{
	
	BMenu* menu = Menu();
	if (menu) {
		BRect itemFrame = Frame();
		
		menu->SetDrawingMode(B_OP_ALPHA);
		
		if(IsMarked()) {
			menu->SetHighColor(M_WHITE_COLOR);
			menu->FillRect(itemFrame);}
		//else			menu->SetHighColor(M_GRAY_COLOR);
			
		if(m_bitmap) menu->DrawBitmap(m_bitmap,m_rect,itemFrame);
	
		if (IsSelected()) {
			menu->SetDrawingMode(B_OP_INVERT);
			menu->SetHighColor(0,0,0);
			menu->FillRect(itemFrame);
		}
		
	}

}

void BitmapMenuItem::GetContentSize(float* width, float* height)
{
	*width=20; 
	*height=20; 
}