
#include "WireMenuItem.h"
#include "cortex_ui.h"

#include "stdio.h"

WireMenuItem::WireMenuItem(BBitmap* start,
								 BBitmap* end,
								 BBitmap* line,
								 int linestyle,
								 BMessage* message)
	: BMenuItem(NULL, message,0),
	bit_start(start),bit_end(end),bit_line(line),m_linestyle(linestyle)
{

}

void WireMenuItem::Draw(void)
{
	
	BMenu* menu = Menu();
	if (menu) {
		BRect r = Frame();
		
		BRect r_line(m_linestyle*20+m_linestyle,0,m_linestyle*20+m_linestyle+20,20);
		
		menu->SetDrawingMode(B_OP_ALPHA);
		
		if(IsMarked()) {
			menu->SetHighColor(M_WHITE_COLOR);
			menu->FillRect(r);
			}
		
		if(bit_start)	
		 menu->DrawBitmap(bit_start,BRect(42,0,62,20),BRect(r.left,r.top,r.left+20,r.top+20));
		 	 else
		 menu->DrawBitmap(bit_line,r_line,BRect(r.left,r.top,r.left+20,r.top+20));
		
		menu->DrawBitmap(bit_line,r_line,BRect(r.left+21,r.top,r.left+41,r.top+20));
		menu->DrawBitmap(bit_line,r_line,BRect(r.left+42,r.top,r.left+62,r.top+20));
		
		
		if(bit_end)
		 menu->DrawBitmap(bit_end,BRect(0,0,20,20),BRect(r.left+63,r.top,r.left+83,r.top+20));
			else
		 menu->DrawBitmap(bit_line,r_line,BRect(r.left+63,r.top,r.left+83,r.top+20));
		 
	
		if (IsSelected()) {
			menu->SetDrawingMode(B_OP_INVERT);
			menu->SetHighColor(0,0,0);
			menu->FillRect(r);
		}
		
	}

}

void WireMenuItem::GetContentSize(float* width, float* height)
{
	*width=85; 
	*height=20; 
}