#ifndef _UITools_
#define _UITools_

#include <Font.h>
#include <View.h>
#include <Application.h>
#include <Roster.h>
#include <Path.h>
#include <Entry.h>
#include <Directory.h>
#include <TranslationUtils.h>

class UITools
{
	public:
	
		UITools(){
		
			regular.SetFamilyAndStyle("Arial","Regular");
			regular.SetSize(10.0);
			
			bold.SetFamilyAndStyle("Arial","Bold");
			bold.SetSize(12.0);
		};
		
		void ApplyRegularFont(BView* v){
		
			v->SetFont(&regular);
		
		};
		
		void ApplyBoldFont(BView* v){
		
			v->SetFont(&bold);
		}
		
		BFont*	getBoldFont(){ return    &bold; }
		BFont*	getRegularFont(){ return &regular; }
		
		BBitmap* LoadBitmap(const char* name){
		
				BPath 		thePath;
				GetResourcesPath(&thePath);
				thePath.Append(name);
				BBitmap* o=BTranslationUtils::GetBitmap(thePath.Path());
				//if(!o) printf("Can't load skin element : %s\n",name);
				return o;
		}
				
		void GetResourcesPath(BPath* thePath){
		
		app_info theInfo;
		BEntry 	theEntry;
		BDirectory theDirectory;
		status_t status = be_app->GetAppInfo(&theInfo);
		if(status == B_OK) {
		
		if(theEntry.SetTo(&theInfo.ref) == B_OK
		&& theEntry.GetParent(&theDirectory) == B_OK) {
			thePath->SetTo(&theDirectory,"resources");
			thePath->InitCheck();
			}
		}  
}
		
	private:
		BFont	regular;
		BFont	bold;	
};
#endif
/*
void
search_fonts()
{
	int32 numFamilies = count_font_families();
	for ( int32 i = 0; i < numFamilies; i++ ) {
	font_family family;
	uint32 flags;
	if(get_font_family(i,&family, &flags)==B_OK){
	printf("font family %s\n",family);
	int32 numStyles = count_font_styles(family);
	for ( int32 j = 0; j < numStyles; j++ ) {
	font_style style;
	if ( get_font_style(family, j, &style, &flags)== B_OK ) 
	{
		printf("     font style %s\n",style);
	}
	} 
	}
	}
}
*/