#ifndef _WireManager_h_
#define _WireManager_h_

#include <List.h>

class MediaWire;
class DiagramEndPoint;
class BView;

enum {
	NO_END = -1,
	AGGREGATION_END = 0,
	COMPOSITION_END = 1,
	NAVIGABILITY_END = 2,
	SUBLASS_END =3,
	LINE=4 //?
};

class WireManager
{
 public:
		WireManager();
		MediaWire	*createWire(DiagramEndPoint*,DiagramEndPoint*,int32 from,int32 to);
		MediaWire	*createWire(DiagramEndPoint*,DiagramEndPoint*);
 
 		void			SetDefaultWire(int index);
 		
 		BView		*getPanel(MediaWire*);
 		
 		void			SetEndPoint(MediaWire*,int32 endpoint,int32 relationid);
 		
 		//protected?
 		BMenu*		CreateDefaultWiresMenu();
 		
 private:
 		BList	*end_bitmap;
 		int 		def_from,def_to,def_line;
 		BBitmap*	getBitmap(int32 i){ return (BBitmap*)end_bitmap->ItemAt(i); };

		struct def_wire {
		
			int	start;
			int	end;
			int  line;
		
		};
		BList	*def_list;
		
		void				add_def(int,int,int);
		int		get_def(int,int);
protected:
	friend MediaWire;	
		BMenu*	CreateMenu(MediaWire * mw,int32 point);
		BMenu*	CreateLineMenu(MediaWire * mw);	
};

#endif